#####################################################################################
#
#	:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]:::
#				 ___                 _
#				| __| __ _  __ _  __| | _ _  ___  _ __
#				| _| / _` |/ _` |/ _` || '_|/ _ \| '_ \
#				|___|\__, |\__, |\__,_||_|  \___/| .__/
#				     |___/ |___/                 |_|
#
#####################################################################################
#
# genlove.tcl v1.0
#
#     .
#
#  :	http://www.magicnet.ee/articles+article.id+5.htm
#
#
#####################################################################################
# 
# : 1)     scripts
#			 2)  eggdrop.conf  source scripts/genname.tcl
#
# .chanset # [+|-]genlove - |    
#
# : ! lubimoy -     ;
#				 ! lubimomu -     ;
#
#####################################################################################
#
#	08.04.2008
#	v1.0 Edit by adium
#	-    .
#
#####################################################################################

namespace eval genlove {
	variable author			{adium@RusNet}
	variable version		{1.0}
	variable date			{08-APR-2008}
	variable unamespace		[string range [namespace current] 2 end]
	variable chflag			$unamespace
	variable pause			{10}
	
	setudef flag			$chflag
	
	if {![info exists egglib(ver)]} {
		setudef flag		usecolors
	}

	variable prefix			{!}
	variable flags			{-|-}

	variable binds			{}

	foreach b [split $binds " "] {
		bind pub ${flags} "${prefix}${b}" [namespace current]::main
	}

	proc main {nick uhost hand chan text} {
		variable chflag
		if {![channel get $chan $chflag]} { return 0 }
		variable pause
		variable lastcall
		if {[info exists lastcall($uhost)]} {
			if {[expr [expr [unixtime] - $lastcall($uhost)] < $pause]} {
				set det [expr [unixtime] - $lastcall($uhost)]
				set wtime [expr $pause - $det]
				variable prefix
				putserv "NOTICE $nick :\00314    \00304${prefix}\00314  \00310[timereplace $wtime]\003"
				return 0
			}
		}
		set lastcall($uhost) [unixtime]
		set text [string tolower [lindex [string range [join $text] 0 end] 0]]
		switch -- $text {
			{woman} - {lubimoy} - {} {
				set l1 [list , , "  :" " ," " ," "," "y ," "," "" " ," " ," " ," " ," ", " "  ,"]
				set l2 [list "  " "    " "    " "   " "   " "    " "   " "    " "    " "  ,      ," "     " "   " "    " "    ,    ," "   "]
				set l3 [list "     " "       " " -   ,       " "    " "   " "    ,  " "    " "    " "        " "     " " " " " " ,  " "      " "   "]
				set l4 [list ",     ." ",    ." . ",  ,   - !" ",     ,    !" ",         ." ",      ." ",     ." . ",      ." ",         !" ",     ."]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]][lindex $l4 [rand [llength $l4]]]"
				if {[channel get $chan usecolors]} {
					putserv "PRIVMSG $chan :$nick, \00303   : \00314$name\003"
				} else {
					putserv "PRIVMSG $chan :$nick,    : $name"
				}
				return 0
			}
			{man} - {lubimomu} - {} {
				set l1 [list " ," "," " ,:" "," " ," "," " , " "  :" "" " ," " ," "p  ," " ," ", " "  , "]
				set l2 [list "  " "    " "    " "   " "      " "   " "   " "    " "   ,    ," "   " "   " "   " "   " "    ,   ," "   "]
				set l3 [list "   " "       " " -   ,       " "    " "   " "     (  )" "    " "    " "       " "   " "  " "  " "  ,  " "      " "   "]
				set l4 [list ",    ." ",    ." ",     ,   -  ." ",      ." ",       ." ",     ." "     ." ",      ." ",         !" ",     ."]
				set name "[lindex $l1 [rand [llength $l1]]][lindex $l2 [rand [llength $l2]]][lindex $l3 [rand [llength $l3]]][lindex $l4 [rand [llength $l4]]]"
				if {[channel get $chan usecolors]} {
					putserv "PRIVMSG $chan :$nick, \00303   : \00314$name\003"
				} else {
					putserv "PRIVMSG $chan :$nick,    : $name"
				}
				return 0
			}
			default {
				putserv "NOTICE $nick :\00314 \00304${prefix} \00314<\00304|\00314>\003"
				return 0
			}
		}
	}

	proc timereplace {text} {
		set text [duration $text]
		set t [lindex $text end-1]
		set m [lindex $text end-3]
		set ti 0
		set mi 0

		if {$t == "0" || $t == "11" || $t == "12" || $t == "13" || $t == "14"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t == "1"} {
			regsub -all -- {second} $text {} text
			set ti 1
		} elseif {$t == "2" || $t == "3" || $t == "4"} {
			regsub -all -- {seconds} $text {} text
			set ti 1
		} elseif {$t >= 5 && !$ti} {
			switch -- [string index $t end] { 
				0 { regsub -all -- {seconds} $text {} text }
				1 { regsub -all -- {seconds} $text {} text }
				2 - 3 - 4 { regsub -all -- {seconds} $text {} text }
				default { regsub -all -- {seconds} $text {} text }
			}
		}
		if {$m == "0" || $m == "11" || $m == "12" || $m == "13" || $m == "14"} {
			regsub	-all	--	{minutes}	$text	{}		text
			set mi 1
		} elseif {$m == "1"} {
			regsub	-all	--	{minute}	$text	{}	text
			set mi 1
		} elseif {$m == "2" || $m == "3" || $m == "4"} {
			regsub	-all	--	{minutes}	$text	{}	text
			set mi 1
		} elseif {$m >= 5 && !$mi} {
			switch -- [string index $m end] {
				0 { regsub -all -- {minutes} $text {} text }
				1 { regsub -all -- {minutes} $text {} text }
				2 - 3 - 4 { regsub -all -- {minutes} $text {} text }
				default { regsub -all -- {minutes} $text {} text }
			}
		}
		return $text
	}

	putlog "[namespace current]:: v$version \[$date\] by $author loaded."
}